/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr.component;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.jcr.ImportUUIDBehavior;
import javax.jcr.InvalidSerializedDataException;
import javax.jcr.ItemExistsException;
import javax.jcr.Node;
import javax.jcr.PathNotFoundException;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.lock.LockException;
import javax.jcr.nodetype.ConstraintViolationException;
import javax.jcr.version.VersionException;

import org.exoplatform.faces.core.component.InformationProvider;
import org.exoplatform.faces.core.component.UIRadioBox;
import org.exoplatform.faces.core.component.UISimpleMulltipartForm;
import org.exoplatform.faces.core.component.UIUploadInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.portlets.content.jcr.component.UIViewController.CancelActionListener;

/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIImport extends UISimpleMulltipartForm implements ChangeNodeListener{
  private static List OPTIONS ;
  
   static {
     OPTIONS = new ArrayList(6) ;
     OPTIONS.add(new SelectItem("#{UIImport.label.doc-view-type}", "doctype")) ;
     OPTIONS.add(new SelectItem("#{UIImport.label.sys-view-type}", "systype")) ;
   }
   
  public UIImport() {
    super("importForm", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIUploadInput("upload1"));
    add(new UIUploadInput("upload2"));
    add(new UIUploadInput("upload3"));
    add(new UIRadioBox("type", "doctype", OPTIONS).setAlign(UIRadioBox.VERTICAL_ALIGN));
    addActionListener(ImportActionListener.class, SAVE_ACTION) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
  }
  
  public String getSaveAction() { return SAVE_ACTION ; }
  
  public void  onChange(UIJCRExplorer uiExplorer, Node node)  throws Exception {
    setRendered(false) ;
  }
  
  static public class ImportActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception  {
      UIImport uicomp = (UIImport) event.getComponent() ;
      UIJCRExplorer uiExplorer = 
        (UIJCRExplorer) uicomp.getAncestorOfType(UIJCRExplorer.class);
      Information iprovider = findInformationProvider(uicomp);
      Node node = uiExplorer.getSelectNode() ;
      Session session = uiExplorer.getSession() ;
      //boolean useDocumentType = "doctype".equals(uicomp.getUIRadioBox("type").getValue());
      Iterator i = uicomp.getUIInputs().values().iterator() ;
      while(i.hasNext()) {
        Object obj = i.next() ;
        if(obj instanceof UIUploadInput) {
          UIUploadInput uiupload = (UIUploadInput) obj ;
          byte[] content = uiupload.getContent()  ;
          if(uiupload.getContent() == null || content.length == 0 ) continue ;
          try {
            session.importXML(node.getPath(), new ByteArrayInputStream(content), 
                ImportUUIDBehavior.IMPORT_UUID_CREATE_NEW) ;
          } catch (Exception e) {
            JCRExceptionManager.process(iprovider, e);
          }
        }
      }
    }
  }
}