package org.exoplatform.services.cms.actions;

import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;

public class ActionMixin extends NodeTypeImpl {

  public ActionMixin(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:actionable";
    this.mixin = true;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[0];
          
    this.declaredChildNodeDefinitions = new NodeDefinition[1];
    NodeType[] types = {manager.getNodeType("exo:action")};
    this.declaredChildNodeDefinitions[0] = new NodeDefinitionImpl(
        ItemDefinitionImpl.RESIDUAL_SET,
        this,
        types,
        null,
        false,
        false,
        OnParentVersionAction.VERSION,
        false,
        true);    
  }
}