/*
 * Created on Mar 22, 2005
 */
package org.exoplatform.services.cms.publications.impl;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

/**
 * @author benjaminmestrallet
 */
public class ArticleNodeType extends NodeTypeImpl {

  public ArticleNodeType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:article";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[3];
    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "exo:title",                 //name
        this,                        //declaringNodeType
        PropertyType.STRING,         //requiredType
        null,                        //valueConstraints 
        NULL_VALUES,                        //defaultValues
        false,                       //autoCreate       
        true,                        //mandatory        
        OnParentVersionAction.COPY,  //onVersion        
        false,                       //readOnly         
        false                        //multiple         
        );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "exo:summary",               //name
        this,                       //declaringNodeType
        PropertyType.STRING,         //requiredType
        null,                        //valueConstraints 
        NULL_VALUES,                       //defaultValues
        false,                       //autoCreate       
        false,                        //mandatory
        OnParentVersionAction.COPY,  //onVersion        
        false,                       //readOnly         
        false                        //multiple         
        );

    this.declaredPropertyDefinitions[2] = new PropertyDefinitionImpl(
        "exo:text",                  //name
        this,                        //declaringNodeType
        PropertyType.STRING,         //requiredType
        null,                        //valueConstraints 
        NULL_VALUES,                        //defaultValues
        false,                       //autoCreate       
        false,                       //mandatory
        OnParentVersionAction.COPY,  //onVersion        
        false,                       //readOnly         
        false                        //multiple         
        );    
    
    this.declaredChildNodeDefinitions = new NodeDefinition[1];
    NodeType[] types = {manager.getNodeType("nt:resource")};
    this.declaredChildNodeDefinitions[0] = new NodeDefinitionImpl(
        "exo:image",                            // name
        this,                                   // declaringNodeType
        types,                                  // requiredNodeTypes
        manager.getNodeType("nt:resource"),     // defaultNodeType
        false,                                  // autoCreate       
        false,                                  // mandatory        
        OnParentVersionAction.VERSION,          // onVersion        
        false,                                  // protected        
        false                                   // same-name sibling
        );

  }

}
