/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import java.util.GregorianCalendar;
import javax.jcr.Node;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.validator.EmptyFieldValidator;
import org.exoplatform.services.pmanager.Constant;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UICommentForm extends UISimpleForm {
  static String NAME = "name".intern(), 
                CREATOR = "creator".intern(), COMMENT = "comment".intern() ;
  
  Node issue_ ;
  Node task_ ;
  
  public UICommentForm() {
    super("UICommentForm", "post", null) ;
    setId("UICommentForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(NAME, "").
        addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(CREATOR, "").
        addValidator(EmptyFieldValidator.class)) ;
    add(new UITextArea(COMMENT, "")) ;
   
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
  }
  
  public void addNewComment(Node issue) throws Exception {
    task_ = null ;
    issue_ = issue ;
    reset() ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UICommentForm uiForm = (UICommentForm) event.getComponent() ;
      Node comments = null ;
      if(uiForm.issue_.hasNode(Constant.ISSUE_COMMENTS)) {
        comments = uiForm.issue_.getNode(Constant.ISSUE_COMMENTS) ;
      } else {
        comments = uiForm.issue_.addNode(Constant.ISSUE_TASKS, Constant.CONTAINER_NODE_TYPE) ;
      }
      Node node = comments.addNode(uiForm.getUIStringInput(NAME).getValue(), 
                                   Constant.ISSUE_COMMENT_NODE_TYPE) ;
      node.setProperty(Constant.ISSUE_COMMENT_CREATOR, 
                       uiForm.getUIStringInput(CREATOR).getValue()) ;
      node.setProperty(Constant.ISSUE_COMMENT_DATA, 
                       uiForm.getUIStringInput(COMMENT).getValue()) ;
      node.setProperty(Constant.ISSUE_COMMENT_CREATED_DATE, new GregorianCalendar()) ;
      uiForm.issue_.save() ;
      uiForm.setRenderedSibling(UIIssue.class);
    }
  }
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UICommentForm uiForm = (UICommentForm) event.getComponent() ;
      uiForm.setRenderedSibling(UIIssue.class);
		}
	}
}