/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import java.util.ArrayList;
import java.util.List;
import javax.jcr.Node;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.Constant;
import org.exoplatform.services.pmanager.DocumentUtil;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIDocumentForm extends UISimpleForm {
  static String NAME= "name", MIME="mimeType" , DOCUMENT = "document"  ;
  static List MIME_OPTIONS ;
  static {
    MIME_OPTIONS = new ArrayList(5) ;
    MIME_OPTIONS.add(new SelectItem("Binary", "application/octet-stream")) ;
    MIME_OPTIONS.add(new SelectItem("text/plain", "text/plain")) ;
    MIME_OPTIONS.add(new SelectItem("text/xhtml", "text/xhtml")) ;
    MIME_OPTIONS.add(new SelectItem("text/xml", "text/xml")) ;
    MIME_OPTIONS.add(new SelectItem("text/wiki", "text/wiki")) ;
  }
  
  Node  node_ ;
  Class backComponent_ ;
  
  public UIDocumentForm() {
    super("documentForm", "post", null) ;
    setId("UIIssueForm") ;
    setClazz("UIExoForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(NAME, "")) ;
    add(new UISelectBox("mimeType", "application/octet-stream", MIME_OPTIONS)) ;
    add(new UITextArea(DOCUMENT, "").setClassCss("large")) ;
   
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
  }
  
  public void setData(Node node, Class backComponent) {  
    node_ = node ;
    backComponent_ = backComponent ;
    reset() ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIDocumentForm uiForm = (UIDocumentForm) event.getComponent() ;
      uiForm.setRenderedSibling(UIProjectManager.class) ;
      String name = uiForm.getUIStringInput(NAME).getValue() ;
      String mimeType = uiForm.getUISelectBox(MIME).getValue() ;
      Node document = DocumentUtil.createDocument(uiForm.node_, "exo", name, mimeType) ;
      document.setProperty(Constant.DOCUMENT_DATA, 
                           uiForm.getUIStringInput(DOCUMENT).getValue()) ;
      uiForm.node_.save() ;
      uiForm.setRenderedSibling(uiForm.backComponent_);
		}
	}
  
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIDocumentForm uiForm = (UIDocumentForm) event.getComponent() ;
      uiForm.setRenderedSibling(uiForm.backComponent_);
		}
	}
}