/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.Constant;
import org.exoplatform.services.pmanager.Project;
import org.exoplatform.services.pmanager.ProjectACL;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIIssue extends UIExoCommand {
  static String NEW_TASK = "newTask" ;
  static String REMOVE_TASK = "removeTask" ;
  static String EDIT_TASK = "editTask" ;
  static String NEW_COMMENT = "newComment" ;
  static String REMOVE_COMMENT = "removeComment" ;
  static String NEW_RESOURCE = "newResource" ;
  static String REMOVE_RESOURCE = "removeResource" ;
  static String VIEW_RESOURCE = "viewResource" ;
  
  static Parameter[] BACK_PARAMS = { new Parameter(ACTION , CANCEL_ACTION)} ;
  static Parameter[] EDIT_PARAMS = { new Parameter(ACTION , EDIT_ACTION)} ;
  static Parameter[] NEW_TASK_PARAMS = { new Parameter(ACTION , NEW_TASK)} ;
  static Parameter[] EDIT_TASK_PARAMS = { new Parameter(ACTION , EDIT_TASK)} ;
  static Parameter[] REMOVE_TASK_PARAMS = { new Parameter(ACTION , REMOVE_TASK)} ;
  static Parameter[] NEW_COMMENT_PARAMS = { new Parameter(ACTION , NEW_COMMENT)} ;
  static Parameter[] REMOVE_COMMENT_PARAMS = { new Parameter(ACTION , REMOVE_COMMENT)} ;
  static Parameter[] NEW_RESOURCE_PARAMS = { new Parameter(ACTION , NEW_RESOURCE)} ;
  static Parameter[] REMOVE_RESOURCE_PARAMS = { new Parameter(ACTION , REMOVE_RESOURCE)} ;
  static Parameter[] VIEW_RESOURCE_PARAMS = { new Parameter(ACTION , VIEW_RESOURCE)} ;
  
  Project project_ ;
  Node issue_ ;
  Class backComponent_ ;
  
  public UIIssue() throws Exception {
    setId("UIDocuments") ;
    setRendererType("VelocityRenderer") ;
    addActionListener(BackActionListener.class, CANCEL_ACTION) ;
    addActionListener(EditActionListener.class, EDIT_ACTION) ;
    addActionListener(NewTaskActionListener.class, NEW_TASK) ;
    addActionListener(EditTaskActionListener.class, EDIT_TASK) ;
    addActionListener(RemoveTaskActionListener.class, REMOVE_TASK) ;
    addActionListener(NewCommentActionListener.class, NEW_COMMENT) ;
    addActionListener(RemoveCommentActionListener.class, REMOVE_COMMENT) ;
    addActionListener(NewResourceActionListener.class, NEW_RESOURCE) ;
    addActionListener(RemoveResourceActionListener.class, REMOVE_RESOURCE) ;
    addActionListener(ViewResourceActionListener.class, VIEW_RESOURCE) ;
  }
 
  public Parameter[] getBackParams() { return BACK_PARAMS ; }
  public Parameter[] getEditParams() { return EDIT_PARAMS ; }
  public Parameter[] getNewTaskParams() { return NEW_TASK_PARAMS ; }
  public Parameter[] getEditTaskParams() { return EDIT_TASK_PARAMS ; }
  public Parameter[] getRemoveTaskParams() { return REMOVE_TASK_PARAMS ; }
  public Parameter[] getNewCommentParams() { return NEW_COMMENT_PARAMS ; }
  public Parameter[] getRemoveCommentParams() { return REMOVE_COMMENT_PARAMS ; }
  public Parameter[] getNewResourceParams() { return NEW_RESOURCE_PARAMS ; }
  public Parameter[] getRemoveResourceParams() { return REMOVE_RESOURCE_PARAMS ; }
  public Parameter[] getViewResourceParams() { return VIEW_RESOURCE_PARAMS ; }
  
  public ProjectACL getProjectACL() { return project_.getProjectACL() ; }
  
  public void setData(Project project, Node issue, Class backComponent) throws Exception { 
    project_ = project ;
    issue_ = issue ;
    backComponent_ = backComponent ;
  } 
  
  public String getCreator() throws Exception {
    return issue_.getProperty(Constant.ISSUE_CREATOR).getString() ;
  }
  
  public String getType() throws Exception {
    return issue_.getProperty(Constant.ISSUE_TYPE).getString() ;
  }
  
  public String getSummary() throws Exception {
    return issue_.getProperty(Constant.ISSUE_SUMMARY).getString() ;
  }
  
  public String getStatus() throws Exception {
    return issue_.getProperty(Constant.ISSUE_STATUS).getString() ;
  }
  
  public String getDueDate() throws Exception {
    return issue_.getProperty(Constant.ISSUE_DUE_DATE).getString() ;
  }
  
  public String getAssignee() throws Exception {
    return issue_.getProperty(Constant.ISSUE_ASSIGNEE).getString() ;
  }
  
  public String getReporter() throws Exception {
    return issue_.getProperty(Constant.ISSUE_REPORTER).getString() ;
  }
  
  public String getDescription() throws Exception {
    return issue_.getProperty(Constant.ISSUE_DESCRIPTION).getString() ;
  }
  
  public String getResolution() throws Exception {
    return issue_.getProperty(Constant.ISSUE_RESOLUTION).getString() ;
  }
  
  public NodeIterator getTasks() throws Exception {
    if(issue_.hasNode(Constant.ISSUE_TASKS)) {
      return issue_.getNode(Constant.ISSUE_TASKS).getNodes() ;
    }
    return null  ;
  }
  
  public String getTaskName(Node node) throws Exception {
    return node.getName();
  }
  
  public String getTaskAssignee(Node node) throws Exception {
    return node.getProperty(Constant.ISSUE_TASK_ASSIGNEE).getString() ;
  }
  
  public String getTaskStatus(Node node) throws Exception {
    return node.getProperty(Constant.ISSUE_TASK_STATUS).getString() ;
  }
  
  public String getTaskTodo(Node node) throws Exception {
    return node.getProperty(Constant.ISSUE_TASK_TODO).getString() ;
  }
  
  public NodeIterator getComments() throws Exception {
    if(issue_.hasNode(Constant.ISSUE_COMMENTS)) {
      return issue_.getNode(Constant.ISSUE_COMMENTS).getNodes() ;
    }
    return null  ;
  }
  
  public String getCommentCreator(Node node) throws Exception {
    return node.getProperty(Constant.ISSUE_COMMENT_CREATOR).getString() ;
  }
  
  public String getCommentCreatedDate(Node node) throws Exception {
    return node.getProperty(Constant.ISSUE_COMMENT_CREATED_DATE).getString() ;
  }
  
  public String getCommentData(Node node) throws Exception {
    return node.getProperty(Constant.ISSUE_COMMENT_DATA).getString() ;
  }
  
  public boolean hasResources() throws Exception {
    return issue_.hasNode(Constant.ISSUE_RESOURCES) ;
  }
  
  public NodeIterator getResources() throws Exception {
    return issue_.getNode(Constant.ISSUE_RESOURCES  ).getNodes() ;
  }
  
  public String getResourceMimeType(Node node) throws Exception {
    return node.getProperty(Constant.DOCUMENT_MIMETYPE).getString() ;
  }
  
  static public class BackActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssue uicomp = (UIIssue) event.getComponent() ;
      uicomp.setRenderedSibling(uicomp.backComponent_) ;
    }
  }  
  
  static public class EditActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssue uicomp = (UIIssue) event.getComponent() ;
      UIIssueForm uiForm = (UIIssueForm) uicomp.getSibling(UIIssueForm.class);
      uiForm.editIssue(uicomp.project_, uicomp.issue_, UIIssue.class) ;
      uicomp.setRenderedSibling(UIIssueForm.class) ;
    }
  }  
  
  static public class NewTaskActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssue uicomp = (UIIssue) event.getComponent() ;
      UITaskForm uiForm = (UITaskForm) uicomp.getSibling(UITaskForm.class);
      uiForm.addNewTask(uicomp.project_, uicomp.issue_) ;
      uicomp.setRenderedSibling(UITaskForm.class) ;
    }
  }  
  
  static public class EditTaskActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssue uicomp = (UIIssue) event.getComponent() ;
      String taskName = event.getParameter(OBJECTID) ;
      UITaskForm uiForm = (UITaskForm) uicomp.getSibling(UITaskForm.class);
      uiForm.editTask(uicomp.project_, uicomp.issue_, taskName) ;
      uicomp.setRenderedSibling(UITaskForm.class) ;
    }
  }  
  
  static public class RemoveTaskActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssue uicomp = (UIIssue) event.getComponent() ;
      Node tasks = uicomp.issue_.getNode(Constant.ISSUE_TASKS) ;
      String taskName = event.getParameter(OBJECTID) ;
      tasks.getNode(taskName).remove() ;
      tasks.save() ;
    }
  }  
  
  static public class NewCommentActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssue uicomp = (UIIssue) event.getComponent() ;
      UICommentForm uiForm = (UICommentForm) uicomp.getSibling(UICommentForm.class);
      uiForm.addNewComment(uicomp.issue_) ;
      uicomp.setRenderedSibling(UICommentForm.class) ;
    }
  }  
  
  static public class RemoveCommentActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssue uicomp = (UIIssue) event.getComponent() ;
      Node comments = uicomp.issue_.getNode(Constant.ISSUE_COMMENTS) ;
      String comment = event.getParameter(OBJECTID) ;
      comments.getNode(comment).remove() ;
      comments.save() ;
    }
  }  
  
  static public class NewResourceActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssue uicomp = (UIIssue) event.getComponent() ;
      UIUploadForm uiForm = (UIUploadForm) uicomp.getSibling(UIUploadForm.class);
      uiForm.setData(UIUploadForm.UPLOAD_ISSUE_DOCUMENT, uicomp.issue_, UIIssue.class) ;
      uicomp.setRenderedSibling(UIUploadForm.class) ;
    }
  }  
  
  static public class RemoveResourceActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssue uicomp = (UIIssue) event.getComponent() ;
      Node resources = uicomp.issue_.getNode(Constant.ISSUE_RESOURCES) ;
      String comment = event.getParameter(OBJECTID) ;
      resources.getNode(comment).remove() ;
      resources.save() ;
    }
  }  
  
  static public class ViewResourceActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssue uicomp = (UIIssue) event.getComponent() ;
      Node resources = uicomp.issue_.getNode(Constant.ISSUE_RESOURCES) ;
      String documentName = event.getParameter(OBJECTID) ;
      Node document = resources.getNode(documentName) ;
      UIDocument uiDocument = (UIDocument) uicomp.getSibling(UIDocument.class);
      uiDocument.setData(document, UIIssue.class) ;
      uicomp.setRenderedSibling(UIDocument.class);
    }
  }  
}