/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import java.util.ArrayList;
import java.util.List;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.indexing.SingleFieldSearchInput;
import org.exoplatform.services.jcr.index.JCRIndexerPlugin;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: UISearch.java,v 1.4 2004/10/20 18:46:31 benjmestrallet Exp $
 */
public class UIIssueAdvancedSearch extends  UISimpleForm {
  static final public String SEARCH_ACTION = "search" ;
  static final public String NODE_NAME = "nodeName", PATH_PATTERN = "pathPattern",
                             NODE_TYPE = "nodeType", OWNER="owner",  DATA = "data" ;
  
  public UIIssueAdvancedSearch() throws Exception {
    super("searchForm", "post", null) ;
  	setId("UIAdvancedSearch") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    setClazz("UIAdvancedSearch");
    
    add(new UIStringInput(NODE_NAME, "")) ;
    add(new UIStringInput(NODE_TYPE, "")) ;
    add(new UIStringInput(PATH_PATTERN, "")) ;
    add(new UIStringInput(OWNER, "")) ;
    add(new UIStringInput(DATA, "")) ;
    
    addActionListener(SearchActionListener.class, SEARCH_ACTION) ;
  }
  
  public String getSearchAction() { return SEARCH_ACTION ; }
  
  static public class SearchActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIIssueAdvancedSearch uiForm =  (UIIssueAdvancedSearch) event.getSource();
      List inputs = new ArrayList() ;
      String value = uiForm.getUIStringInput(NODE_NAME).getValue() ;
      if(value.length() > 0) {
        inputs.add(new SingleFieldSearchInput(JCRIndexerPlugin.NAME_FIELD, value)) ;
      }
      value = getExactMatchExpression(uiForm.getUIStringInput(NODE_TYPE).getValue()) ;
      if(value != null) {
        inputs.add(new SingleFieldSearchInput(JCRIndexerPlugin.NODE_TYPE_FIELD, value)) ;
      }
      value = uiForm.getUIStringInput(PATH_PATTERN).getValue() ;
      if(value.length() > 0) {
        inputs.add(new SingleFieldSearchInput(JCRIndexerPlugin.PATH_FIELD, value)) ;
      }
      value = uiForm.getUIStringInput(OWNER).getValue() ;
      if(value.length() > 0) {
        inputs.add(new SingleFieldSearchInput(JCRIndexerPlugin.OWNER_FIELD, value)) ;
      }
      value = uiForm.getUIStringInput(DATA).getValue() ;
      if(value.length() > 0) {
        inputs.add(new SingleFieldSearchInput(JCRIndexerPlugin.DATA_FIELD, value)) ;
      }
      UIIssueSearcher uiSearcher = (UIIssueSearcher) uiForm.getAncestorOfType(UIIssueSearcher.class) ;
      uiSearcher.advancedSearch(inputs, null) ;
    }
    
    private String getExactMatchExpression(String s) {
      if(s == null || s.length() == 0) return null ;
      if(s.charAt(0) == '\"' && s.charAt(s.length() - 1) == '\"') return s;
      return '\"' + s + '\"' ;
    }
  } 
}