/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import javax.jcr.Node;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.validator.EmptyFieldValidator;
import org.exoplatform.services.pmanager.Constant;
import org.exoplatform.services.pmanager.Project;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIProjectPermissionsForm extends UISimpleForm {
  static String VIEW_ISSUE = "viewIssue".intern(), CREATE_ISSUE = "createIssue".intern(), 
                ADMIN_ISSUE = "adminIssue".intern(), VIEW_DOC = "viewDocument".intern(),
                CREATE_DOC = "createDocument".intern(), ADMIN_DOC = "adminDocument".intern(), 
                ADMIN_PROJECT = "adminProject".intern();
  
  Project project_ ;
  Class backComponent_ ;
  
  public UIProjectPermissionsForm() {
    super("UIProjectPermissions", "post", null) ;
    setId("UIProjectPermissions") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(VIEW_ISSUE, "").addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(CREATE_ISSUE, "").addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(ADMIN_ISSUE, "").addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(VIEW_DOC, "").addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(VIEW_DOC, "").addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(CREATE_DOC, "").addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(ADMIN_DOC, "").addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(ADMIN_PROJECT, "").addValidator(EmptyFieldValidator.class)) ;
   
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
  }
  
  public void setData(Project project , Class backComponent) throws Exception {
    project_ = project ;
    backComponent_ = backComponent ;
    Node permissions = project.getPermissions() ; 
    setFieldValue(VIEW_ISSUE, permissions.getProperty(Constant.PROJECT_PERMISSION_VIEW_ISSUE).getString());
    setFieldValue(CREATE_ISSUE, permissions.getProperty(Constant.PROJECT_PERMISSION_CREATE_ISSUE).getString());
    setFieldValue(ADMIN_ISSUE, permissions.getProperty(Constant.PROJECT_PERMISSION_ADMIN_ISSUE).getString());
    setFieldValue(VIEW_DOC, permissions.getProperty(Constant.PROJECT_PERMISSION_VIEW_DOCUMENT).getString());
    setFieldValue(CREATE_DOC, permissions.getProperty(Constant.PROJECT_PERMISSION_CREATE_DOCUMENT).getString());
    setFieldValue(ADMIN_DOC, permissions.getProperty(Constant.PROJECT_PERMISSION_ADMIN_DOCUMENT).getString());
    setFieldValue(ADMIN_PROJECT, permissions.getProperty(Constant.PROJECT_PERMISSION_ADMIN_PROJECT).getString());
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIProjectPermissionsForm uiForm = (UIProjectPermissionsForm) event.getComponent() ;
      Node permissions = uiForm.project_.getPermissions() ;
      permissions.setProperty(Constant.PROJECT_PERMISSION_VIEW_ISSUE, 
                              uiForm.getUIStringInput(VIEW_ISSUE).getValue()) ;
      permissions.setProperty(Constant.PROJECT_PERMISSION_CREATE_ISSUE, 
                              uiForm.getUIStringInput(CREATE_ISSUE).getValue()) ;
      permissions.setProperty(Constant.PROJECT_PERMISSION_ADMIN_ISSUE, 
                              uiForm.getUIStringInput(ADMIN_ISSUE).getValue()) ;
      permissions.setProperty(Constant.PROJECT_PERMISSION_VIEW_DOCUMENT,
                              uiForm.getUIStringInput(VIEW_DOC).getValue()) ;
      permissions.setProperty(Constant.PROJECT_PERMISSION_CREATE_DOCUMENT,
                              uiForm.getUIStringInput(CREATE_DOC).getValue()) ;
      permissions.setProperty(Constant.PROJECT_PERMISSION_ADMIN_DOCUMENT, 
                              uiForm.getUIStringInput(ADMIN_DOC).getValue()) ;
      permissions.setProperty(Constant.PROJECT_PERMISSION_ADMIN_PROJECT,
                              uiForm.getUIStringInput(ADMIN_PROJECT).getValue()) ;
      permissions.save() ;
      uiForm.setRenderedSibling(uiForm.backComponent_);
    }
  }
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIProjectPermissionsForm uiForm = (UIProjectPermissionsForm) event.getComponent() ;
      uiForm.setRenderedSibling(uiForm.backComponent_);
		}
	}
}