/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.forum.hibernate;

import java.util.zip.ZipFile;
import java.util.zip.ZipOutputStream;

import org.exoplatform.container.xml.InitParams;
import org.exoplatform.services.backup.ImportExportPlugin;
import org.exoplatform.services.backup.Metadata;
import org.exoplatform.services.database.HibernateService;
import org.hibernate.Session;
/**
 * May 27, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $ID$
 **/
public class ImportExportPluginImpl extends ImportExportPlugin {
  
  static String SERVICE_META_DATA_ENTRY   = "metadata.xml" ;
  
  private HibernateService hservice_;

  public ImportExportPluginImpl(HibernateService hservice, InitParams params) throws Exception {
    init(params) ;
    this.hservice_ = hservice;
  }
  
  public boolean hasUserData()  { return false ;  }
  
  public void exportUserData(String user, ZipOutputStream os) throws Exception {   
  }

  public void importUserData(String user, ZipFile in) throws Exception {
  }

  public void exportServiceData( ZipOutputStream os) throws Exception {
    Metadata mdata = new Metadata(getCurrentDataVersion(), getDescription(), "single-service") ;
    createEntry(SERVICE_META_DATA_ENTRY , os, mdata) ; 
    Session session = hservice_.openSession();    
    ForumExporter exporter = new ForumExporter(session, os) ; 
    exporter.export() ;
  }

  public void importServiceData( ZipFile in) throws Exception {
    Session session = hservice_.openSession();    
    ForumImporter importer = new ForumImporter(this, session,in) ;
    importer.importData() ;
  }
}