/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.pmanager;

import java.io.InputStream;
import java.util.GregorianCalendar;
import javax.jcr.Node;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Apr 4, 2005
 * @version $Id$
 */
public class DocumentUtil {
  static public Node createDocument(Node node, String owner, 
                                    String name, String mimeType) throws Exception {
    Node document = node.addNode(name, Constant.DOCUMENT_NODE_TYPE);
    document.setProperty(Constant.DOCUMENT_OWNER, owner);
    document.setProperty(Constant.DOCUMENT_MIMETYPE, mimeType);
    GregorianCalendar date = new GregorianCalendar() ;
    document.setProperty(Constant.DOCUMENT_CREATED_DATE, date);
    document.setProperty(Constant.DOCUMENT_MODIFIED_DATE, date);
    return document ;
  }
  
  static public Node createDocument(Node node, String owner, String name, 
                                    String mimeType, InputStream is) throws Exception {
    Node document = node.addNode(name, Constant.DOCUMENT_NODE_TYPE);
    document.setProperty(Constant.DOCUMENT_OWNER, owner);
    document.setProperty(Constant.DOCUMENT_MIMETYPE, mimeType);
    GregorianCalendar date = new GregorianCalendar() ;
    document.setProperty(Constant.DOCUMENT_CREATED_DATE, date);
    document.setProperty(Constant.DOCUMENT_MODIFIED_DATE, date);
    document.setProperty(Constant.DOCUMENT_DATA, is) ;
    return document ;
  }
}
