/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.pmanager;

import javax.jcr.Node;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Apr 4, 2005
 * @version $Id$
 */
public class ProjectUtil {
  static public Node createVersion(Project project, String versionNumber, 
                                   String name, String description) throws Exception {
    Node node = project.getProjectNode();
    Node versions = node.getNode("versions") ;
    Node v = versions.addNode(versionNumber, "exo:resource") ;
    v.setProperty(Constant.PROJECT_VERSION_NUMBER, versionNumber) ;
    v.setProperty(Constant.PROJECT_VERSION_NAME, name) ;
    v.setProperty(Constant.PROJECT_VERSION_DESCRIPTION, description) ;
    return v ;
  }
  
  static public Node createComponent(Project project, 
                                     String name, String description) throws Exception {
    Node node = project.getProjectNode();
    Node components = node.getNode("components") ;
    Node component = components.addNode(name, "exo:resource") ;
    component.setProperty(Constant.PROJECT_COMPONENT_NAME, name) ;
    component.setProperty(Constant.PROJECT_COMPONENT_DESCRIPTION, description) ;
    return component ;
  }
  
  static public Node createParticipant(Project project, 
                                       String username, String description) throws Exception {
    Node node = project.getProjectNode();
    Node components = node.getNode("participants") ;
    Node component = components.addNode(username, "exo:resource") ;
    component.setProperty(Constant.PROJECT_PARTICIPANT_USERNAME, username) ;
    component.setProperty(Constant.PROJECT_PARTICIPANT_DESCRIPTION, description) ;
    return component ;
  }
}
