/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.pmanager.impl.exont;

import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.version.OnParentVersionAction;
import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;

/**
 * @author Tuan Nguyen
 */
public class ContainerType extends NodeTypeImpl {
  
  public ContainerType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:container";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:folder");
    
    //this.declaredPropertyDefinitions = new PropertyDef[0];
    
    this.declaredChildNodeDefinitions = new NodeDefinition[1];
    NodeType[] types = {manager.getNodeType("nt:base")};
    this.declaredChildNodeDefinitions[0] = 
      new NodeDefinitionImpl(ItemDefinitionImpl.RESIDUAL_SET,          // name
                      this,                              // declaringNodeType
                      types,                             // requiredNodeTypes
                      this,                              // defaultNodeType
                      false,                             // autoCreate       
                      false,                              // mandatory        
                      OnParentVersionAction.VERSION,     // onVersion        
                      false,                             // protected        
                      true                               // same-name sibling,     
      );
  }
}
