/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.spider.core.htmlparser;

import java.util.List;

/**
 * Created by The eXo Platform SARL
 * Author : Thuannd
 *         nhudinhthuan@yahoo.com
 * Dec 29, 2005
 */
public interface Node {
  
  /**
   * Lay lai node cha chua node nay
   * @return Node
   * TODO: TO ENGLISH
   */
  public Node getParent();  
  
  /**
   * Dat node cha dong thoi parent cung cap nhat
   *  chinh node nay vao danh sach node con cua no.
   *  @param parent Parent Node
   * TODO: TO ENGLISH
   */
  public void setParent( Node parent);
  
  /**
   * Them node con
   * @param node Sub Node them vao
   * TODO: TO ENGLISH
   */
  public void addChild( Node node); 
  
  /**
   * Lay ra so node con cua node hien tai
   * @return tong so node con
   * TODO: TO ENGLISH
   */
  public int getChildrenSize();
  
  /**
   * Lay lai node con bang chi so
   * @param index Chi so cua node con
   * @return Node con
   * TODO: TO ENGLISH
   */
  public Node getChild( int index); 
  
  /**
   * Loai node con ra khoi danh sach node cua node nay
   * @param index Vi tri node con
   * TODO: TO ENGLISH
   */
  public void removeChild( int index); 
  
  /**
   * Lay lai ten node
   * @return Ten node
   * TODO: TO ENGLISH
   */
  public String getName();
  
  /**
   * Lay lai danh sach cac Attribute cua node nay
   * @return List cac Attribute
   * TODO: TO ENGLISH
   */
  public List<Attribute> getAttributes();
  
  /**
   * Lay lai Attribute theo ten
   * @param name Ten Attribute
   * @return Attribute
   * TODO: TO ENGLISH
   */
  public Attribute getAttribute( String name);
  
  /**
   * Dat lai danh sach cac attribute moi cho Node
   * @param list Danh sach Attribute
   * TODO: TO ENGLISH
   */
  public void setAttributes( List<Attribute> list);
  
  /**
   * Cap nhat gia tri Atttribute moi cho Node. Neu chua co, tu dong them vao
   * @param name Ten cua Attribute
   * @param value Gia tri cua Attribute
   * TODO: TO ENGLISH
   */
  public void setAttribute( String name, String value);
    
  /**
   * Lay lai html text cua Node nay
   * @return HTML content
   * TODO: TO ENGLISH
   */
  public String toHTMLValue();  
}
