/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.spider.htmlparser.impl;

import java.io.File;
import java.util.List;

import org.exoplatform.services.spider.core.htmlparser.Document;
import org.exoplatform.services.spider.core.htmlparser.Node;
import org.exoplatform.services.spider.core.io.DataStream;

/**
 * Created by The eXo Platform SARL
 * Author : Thuannd
 *         nhudinhthuan@yahoo.com
 * Jan 3, 2006
 */
public class DocumentImpl implements Document {
  
  private Node node; 
  
  public DocumentImpl( List<Token> tokens){    
    this.node = (new NodeParser( tokens)).getNode();      
  }
  
  public DocumentImpl(String html) throws Exception {   
    DocumentParser  parser = new DocumentParser(); 
    node = (new NodeParser(  parser.getToken( html))).getNode();   
  }
  
  public DocumentImpl( byte[] data, String charset) throws Exception {
    DocumentParser  parser = new DocumentParser();      
    this.node = (new NodeParser( parser.getToken( data, charset))).getNode(); 
  }
  
  public DocumentImpl( File file, String charset) throws Exception {    
    this( (new DataStream()).load( file), charset);
  }  
  
  public Node getRootNode(){
    return this.node;
  }
  
  public Node findNodeByStructureId(String id) throws Exception {
    if(id.trim().equals("")) return node;
    String [] split = id.split("\\.");
    int index = -1;
    for(String ele : split){
      index = Integer.parseInt(ele);
      if(index >= node.getChildrenSize() || index < 0) throw new Exception("IndexOutofBounds");
      node = node.getChild(index);      
    }
    return node;    
  }
  

}
