<%@ page import='java.util.List' %>
<%@ page import='javax.jcr.*' %>
<%@ page import='javax.naming.*' %>
<%@ page import='org.exoplatform.services.jcr.core.*' %>
<%@ page import='org.exoplatform.services.jcr.config.*' %>
<%@ page import='org.exoplatform.container.monitor.jvm.*' %>
<%
  ManageableRepository repository = null;

  String s = request.getParameter("rep");
  if (s != null) {
    try {
      InitialContext ctx = new InitialContext();
      J2EEServerInfo eesi = new J2EEServerInfo();
      if (eesi.getServerName().equals("tomcat") && (s.indexOf("/") < 0))
        s = "java:comp/env/jcr/" + s;
      repository = (ManageableRepository) ctx.lookup(s);
      request.getSession().setAttribute("repName", s);
    } catch (Exception e) {
      e.printStackTrace();
      System.out.println("!!!ERROR: " + e.toString());
    }
  } 
%>

<html>
<body>
<% if (repository == null) {%>
<h1>Repository "<%= s%>" not found</h1>
<%} else {%>
  <h1>eXo Platform JCR browser sample</h1>
  <form action="index.jsp" method="post">
  Repository selected: <input disabled name="rep0" type="text" maxlength="30" value="<%= s%>">
    <input type="submit" name="submit" value="back <--">
  </form>
  <hr width="25%" align="left">
  <form action="view.jsp" method="post">
    <h2>
    <input name="rep" type="hidden" value="<%= s%>">
    Select workspace:
    <%
      String[] wss = repository.getWorkspaceNames();
      if (wss.length > 0) {%>
    <select name="ws">
      <%for (int i = 0; i < wss.length; i++) {%>
      <option><%= wss[i]%>
      <%}%>
    </select>
    <%}%>
    <input name="submit" type="submit" value="view">
    </h2>
  </form>
<%}%>
  <table border="1" width="100%">
    <tr>
      <td colspan="2" align="center"><h2><u>Descriptors</u></h2></td>
    </tr>
    <tr>
      <td>Name</td>
      <td><%= repository.getDescriptor(Repository.REP_NAME_DESC) %></td>
    </tr>
    <tr>
      <td>Vendor</td>
      <td><%= repository.getDescriptor(Repository.REP_VENDOR_DESC) %></td>
    </tr>
    <tr>
      <td>URL</td>
      <td><%= repository.getDescriptor(Repository.REP_VENDOR_URL_DESC) %></td>
    </tr>
    <tr>
      <td>Repository version</td>
      <td><%= repository.getDescriptor(Repository.REP_VERSION_DESC) %></td>
    </tr>
    <tr>
      <td>Spec name</td>
      <td><%= repository.getDescriptor(Repository.SPEC_NAME_DESC) %></td>
    </tr>
    <tr>
      <td>Spec version</td>
      <td><%= repository.getDescriptor(Repository.SPEC_VERSION_DESC) %></td>
    </tr>
    <tr>
      <td>Level 1 supported</td>
      <td><%= repository.getDescriptor(Repository.LEVEL_1_SUPPORTED) %></td>
    </tr>
    <tr>
      <td>Level 2 supported</td>
      <td><%= repository.getDescriptor(Repository.LEVEL_2_SUPPORTED) %></td>
    </tr>
    <tr>
      <td>Observation supported</td>
      <td><%= repository.getDescriptor(Repository.OPTION_OBSERVATION_SUPPORTED) %></td>
    </tr>
    <tr>
      <td>Versioning supported</td>
      <td><%= repository.getDescriptor(Repository.OPTION_VERSIONING_SUPPORTED) %></td>
    </tr>
    <tr>
      <td>Locking supported</td>
      <td><%= repository.getDescriptor(Repository.OPTION_LOCKING_SUPPORTED) %></td>
    </tr>
    <tr>
      <td>Transactions supported</td>
      <td><%= repository.getDescriptor(Repository.OPTION_TRANSACTIONS_SUPPORTED) %></td>
    </tr>      
    <tr>
      <td>Query SQL supported</td>
      <td><%= repository.getDescriptor(Repository.OPTION_QUERY_SQL_SUPPORTED) %></td>
    </tr>      
  </table>
  <%
    RepositoryEntry cfg = repository.getConfiguration();
    List wsl = cfg.getWorkspaceEntries();
  %>
  <hr width="25%" align="left">
  <table border="1" width="100%">
    <tr>
      <td colspan="2" align="center"><h2><u>Configuration</u></h2></td>
    </tr>
    <%
    if (wsl.size() > 0) {
    for (int i = 0; i < wsl.size(); i++) {
      WorkspaceEntry wse = (WorkspaceEntry) wsl.get(i);
      String[] wsens = new String[3];
      wsens[0] = "container";
      wsens[1] = "query handler";
      wsens[2] = "cache";
      MappedParametrizedObjectEntry[] wses = new MappedParametrizedObjectEntry[3];
      wses[0] = wse.getContainer();
      wses[1] = wse.getQueryHandler();
      wses[2] = wse.getCache();
    %>
    <tr>
      <td><%= wse.getName()%></td>
      <td>
        <table border="1" width="100%">
          <%
            for (int j = 0; j < 3; j++) {
              if (wses[j] != null) {
                List prms = wses[j].getParameters();
          %>
                <%
                  if (prms.size() > 0) {
                %>
                <%
                    for (int k = 0; k < prms.size(); k++) {
                      SimpleParameterEntry p = (SimpleParameterEntry) prms.get(k);
                %>
                <tr>
                <%if (k == 0) {%>
                <td rowspan="<%= (prms.size() > 0 ? prms.size() : 1)%>" width="30%"><%= wsens[j]%>
                  <%if (wses[j].getType() != null) {%>{<%= wses[j].getType()%>}<%}%>
                </td>
                <%}%>
                  <td width="30%"><%= p.getName()%></td><td><%= p.getValue()%></td>
                <%  }
                %>
                </tr>
                <%
                  } else {
                %>
                <tr><h3>-- no params defined --</h3></tr>
                <%}%>
            <%}%>
          <%}%>
        </table>
      </td>
    </tr>
    <%
    }
    }
    %>
  </table>
</body>  
</html>
