/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.jcr.impl.core.nodetype.exo;


import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.PropertyType;
import javax.jcr.version.OnParentVersionAction;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeType;
import javax.jcr.RepositoryException;

/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 5 ao�t 2004
 */
public class MockNodeType extends NodeTypeImpl {

  public MockNodeType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:mockNodeType";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredPropertyDefinitions = new PropertyDefinition[2];

    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "jcr:nodeTypeName",               //name
        this,                       //declaringNodeType
        PropertyType.STRING,         //requiredType
        null,                        //valueConstraints 
        null,                       //defaultValues
        false,                       //autoCreate       
        true,                        //mandatory        
        OnParentVersionAction.COPY,  //onVersion        
        false,                       //readOnly         
        false
        );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "jcr:supertypes",            //name
        this,                       //declaringNodeType
        PropertyType.STRING,         //requiredType
        null,                        //valueConstraints 
        null,                       //defaultValues
        false,                       //autoCreate       
        false,                        //mandatory
        OnParentVersionAction.COPY,  //onVersion        
        false,                       //readOnly         
        false
        );

    this.declaredChildNodeDefinitions = new NodeDefinition[2];
    /* // Commented by Peter Nedonosko, 14.12.2005
    NodeType[] types = {manager.getNodeType("nt:propertyDefinition")};    
    this.declaredChildNodeDefinitions[0] = new NodeDefinitionImpl(
        "jcr:propertyDefinition",
        this,
        types,
        manager.getNodeType("nt:propertyDefinition"),
        false,
        false,
        OnParentVersionAction.VERSION,
        false,
        true);
        */
    NodeType[] types = {manager.getNodeType("nt:childNodeDefinition")};
    this.declaredChildNodeDefinitions[0] = new NodeDefinitionImpl(
        "jcr:childNodeDefinition",                // name
        this,
        types,
        manager.getNodeType("nt:childNodeDefinition"),
        false,
        false,
        OnParentVersionAction.VERSION,
        false,
        true);
    //types[0] = manager.getNodeType("nt:propertyDefinition"); // Commented by Peter Nedonosko, 14.12.2005 
    types[0] = manager.getNodeType("nt:childNodeDefinition");    
    this.declaredChildNodeDefinitions[1] = new NodeDefinitionImpl(
        "jcr:childNodeDefinition",                // name
        this,                              // declaringNodeType
        types,                             // requiredNodeTypes
        manager.getNodeType("nt:childNodeDefinition"),   // defaultNodeType
        false,                             // autoCreate       
        false,                              // mandatory
        OnParentVersionAction.VERSION,     // onVersion        
        false,                             // protected        
        true                               // same-name sibling
        );
  }
}
