/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core.nodetype.mix;

import javax.jcr.Node;
import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.ConstraintViolationException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: LockableType.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class LockableType extends NodeTypeImpl {

  public LockableType(NodeTypeManager manager) throws NoSuchNodeTypeException,
      RepositoryException {
    super(manager);
    this.name = "mix:lockable";
    this.mixin = true;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredPropertyDefinitions = new PropertyDefinition[2];
    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "jcr:lockOwner", // name
        this, // declaringNodeType
        PropertyType.STRING, // requiredType
        EMPTY_CONSTRAINTS, // valueConstraints
        null, // defaultValues //NULL_VALUES
        false, // autoCreate
        false, // mandatory
        OnParentVersionAction.IGNORE, // onVersion
        true, // readOnly
        false // multiple
    );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "jcr:lockIsDeep", // name
        this, // declaringNodeType
        PropertyType.BOOLEAN, // requiredType
        EMPTY_CONSTRAINTS, // valueConstraints
        null, // defaultValues //NULL_VALUES
        false, // autoCreate
        false, // mandatory
        OnParentVersionAction.IGNORE, // onVersion
        true, // readOnly
        false // multiple
    );

  }

}
