/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.jcr.impl.core.observation;

import javax.jcr.RepositoryException;
import javax.jcr.observation.Event;

import org.exoplatform.services.jcr.datamodel.ItemData;
import org.exoplatform.services.jcr.impl.core.SessionImpl;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: EventImpl.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class EventImpl implements Event {

    private int type;
    private String path;
    private String userId;
//    private String uuid;
//    private static final Log log = LogFactory.getLog(EventImpl.class);

    public EventImpl(int type, ItemData item, SessionImpl session) throws RepositoryException {

        this.type = type;
		this.userId = session.getUserID();
		this.path = session.getLocationFactory().createJCRPath(
		    item.getQPath()).getAsString(false);

//		this.path = session.getLocationFactory().
//		createJCRName(item.getQPath().getName()).getAsString();
//		this.uuid = item.glocation.getUUID();
    }

    /**
	 * @see javax.jcr.observation.Event#getType
	 */
    public int getType() {
        return this.type;
    }

    /**
     * @see javax.jcr.observation.Event#getPath
     */
    public String getPath() throws RepositoryException {
        return this.path;
    }

    /**
     * @see javax.jcr.observation.Event#getUserId
     */
    public String getUserID() {
        return this.userId;
    }

//    public String toString() {
//        return "EventImpl: " + type + " " + path + " " + userId;
//    }

//    public String getUUID() {
//        return this.uuid;
//    }


}
