/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core.version;

import javax.jcr.Node;
import javax.jcr.PathNotFoundException;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.Value;
import javax.jcr.nodetype.ConstraintViolationException;
import javax.jcr.version.VersionException;

import org.exoplatform.services.jcr.datamodel.NodeData;
import org.exoplatform.services.jcr.impl.core.NodeImpl;
import org.exoplatform.services.jcr.impl.core.PropertyImpl;
import org.exoplatform.services.jcr.impl.core.RepositoryImpl;
import org.exoplatform.services.jcr.impl.core.SessionImpl;
import org.exoplatform.services.jcr.impl.core.WorkspaceDataManager;
import org.exoplatform.services.jcr.impl.core.WorkspaceImpl;
import org.exoplatform.services.log.LogService;

/**
 * Created by The eXo Platform SARL        .
 * 
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: VersionStorageDescendantNode.java 3510 2005-12-29 17:32:57Z geaz $
 */

public abstract class VersionStorageDescendantNode extends NodeImpl {

  //protected SessionImpl userSession;
  
  public VersionStorageDescendantNode(NodeData data, NodeImpl parent, int state,
      SessionImpl session, LogService logService) throws PathNotFoundException,
      RepositoryException {

    // data retrieving session it is system session (node belongs to systemSession)
    super(data, parent, state, session, 
        //((RepositoryImpl)session.getRepository()).getSystemSession(), 
        logService);
    
    
    
    //this.userSession = session;
    
  }
  
  protected VersionStorageManager versionStorageManager() {
    return ((WorkspaceImpl)session.getWorkspace()).getVersionStorageManager();
  }

  protected WorkspaceDataManager workspaceDataManager() {
    return session.getTransientNodesManager().getWorkspaceDataManager();
  }

  
  public Node addNode(String relPath, String nodeTypeName) throws ConstraintViolationException {
    throw new ConstraintViolationException("jcr:versionStorage is protected");
  }
  
  public Node addNode(String relPath) throws ConstraintViolationException {
    throw new ConstraintViolationException("jcr:versionStorage is protected");
  }
  
  public void addMixin(String mixinName) throws ConstraintViolationException {
    throw new ConstraintViolationException("jcr:versionStorage is protected");
  }
  
  public boolean canAddMixin(String mixinName) throws RepositoryException {
    return false;
  }

  
  protected PropertyImpl doSetProperty(String name, Value[] values, int type,
      boolean multiValued, boolean registerInDataManager, boolean doExternalValidation) 
      throws ConstraintViolationException, VersionException, RepositoryException {
    if(doExternalValidation)
      throw new ConstraintViolationException("jcr:versionStorage is protected");
    else
      return super.doSetProperty(name, values, type, multiValued, 
          registerInDataManager, doExternalValidation);
  }

  
  // getSession() in fact!!
  //public SessionImpl getUserSession() {
  //  return userSession;
  //}

}
