/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL                               *
 * All rights reserved.                                                    *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.importing;

import org.apache.commons.digester.RulesBase;
import javax.jcr.Node;
import javax.jcr.ImportUUIDBehavior;
import java.util.Stack;


/**
 * Created by The eXo Platform SARL
 *  Digester rules for session importer
 *
 * @author <a href="mailto:alex.kravchuk@gmail.com">Alexander Kravchuk</a>
 * @version $Id: SysViewSessionRules.java 3510 2005-12-29 17:32:57Z geaz $
 */
public class SysViewSessionRules extends RulesBase {


    private CommonRule setRuleUuidBehaviour(CommonRule rule, int uuidBehavior){
        rule.setUuidBehavior(uuidBehavior);
        return rule;

    }



    SysViewSessionRules(Node startNode, int uuidBehavior){
        Stack nodesStack = new Stack();
        nodesStack.push(startNode);

        setNamespaceURI("http://www.jcp.org/jcr/sv/1.0");

        add("*/node", setRuleUuidBehaviour(new SysViewNodeRule(nodesStack),uuidBehavior));
        add("*/node/property", setRuleUuidBehaviour(new SysViewPropertyRule(nodesStack),uuidBehavior));
        add("*/node/property/value", setRuleUuidBehaviour(new SysViewValueRule(nodesStack),uuidBehavior));

    }
}
