/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.jcr.impl.mock;

import java.util.HashMap;
import java.util.Map;

import javax.security.auth.Subject;

import org.apache.commons.logging.Log;
import org.exoplatform.services.exception.ExoServiceException;
import org.exoplatform.services.log.LogService;
import org.exoplatform.services.security.SecurityService;
import org.exoplatform.services.security.SubjectEventListener;


/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 28 avr. 2004
 */
public class DummySecurityServiceImpl implements SecurityService {

  private Map subjects;
  private Log log_;

  public DummySecurityServiceImpl(LogService logService) {
    log_ = logService.getLog("org.exoplatform.services.security");
    subjects = new HashMap();
  }

  public boolean authenticate(String login, String password) throws ExoServiceException {
    if (password == null || "".equals(password)) {
      log_.debug("password must not be null or empty");
      throw new ExoServiceException("password must not be null or empty");
    }
    return true;
  }

  public void setUpAndCacheSubject(String userName, Subject value) throws ExoServiceException {
    subjects.put(userName, value);
  }

  public Subject getSubject(String userName) {
    log_.debug("get subject for user " + userName);
    return (Subject) subjects.get(userName);
  }

  public void removeSubject(String userName) {
    log_.debug("remove subject for user " + userName);
    subjects.remove(userName);
  }

  public void addSubjectEvenetListener(SubjectEventListener subjectEventListener) {
    //To change body of implemented methods use File | Settings | File Templates.
  }
  
  
  public Log getLog() { return log_ ;  }

  public boolean isUserInRole(String userName, String role) {
    return false;
  }

  public String getSSOAuthentication() {
    // TODO Auto-generated method stub
    return null;
  }

  public boolean isSSOAuthentication() {
    // TODO Auto-generated method stub
    return false;
  }

  public boolean isStandaloneAuthentication() {
    // TODO Auto-generated method stub
    return false;
  }

  public String getProxyTicket(String userName, String urlOfTargetService) throws Exception {
    // TODO Auto-generated method stub
    return null;
  }

  public boolean hasMembershipInGroup(String user, String roleExpression) {
    // TODO Auto-generated method stub
    return false;
  }

  public boolean hasMembershipInGroup(String userId, String membershipName, String groupName) {
    return true;
  }
}