/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.storage.rdb.container.data;

import org.exoplatform.services.jcr.datamodel.IllegalPathException;
import org.exoplatform.services.jcr.datamodel.InternalQPath;
import org.exoplatform.services.jcr.datamodel.NodeData;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov </a>
 * @version $Id: MultiRDBItemRecord.java 3510 2005-12-29 17:32:57Z geaz $
 * 
 * @hibernate.class table="JCR_MITEM"
 * @hibe---rnate.cache usage="read-write"
 */

public abstract class MultiRDBItemRecord implements ItemRecord {

  protected String id;
  protected String path;
  protected int version;
  protected NodeRecord parentNode;
  protected String parentUUID;

  public MultiRDBItemRecord() {
  }

  /**
   * @hibernate.id generator-class="assigned" column="ID"
   */
  public String  getId() {
    return id;
  }

  public void  setId(String id) {
    this.id = id;
  }

  /**
   * @hibernate.property co--lumn="PATH" n--ot-null="true" un--ique="true"
   * @hibernate.column name="PATH" in--dex="PATH_IDX" not-null="true" 
   */
   public String getPath() {
    return path;
   }

   public void setPath(String path) {
     this.path = path;
   }

   
   /**
    * @hibernate.version column="VERSION"
    */
    public int getPersistedVersion() {
      return version;
    }
   
	public void setPersistedVersion(int version) {
		this.version = version;
	}

   // ----------- ItemData --------------
    public InternalQPath getQPath() {
       try {
       	 return InternalQPath.parse(path);
       } catch (IllegalPathException e) {
         e.printStackTrace();
         throw new RuntimeException(e);
       }
    }
    
 	public String getParentUUID() {
		return parentUUID;
	}
 	
	public String getUUID() {
		return id;
	}

     // ---------------------------------
	
	
	public boolean equals(Object other) {
		if (this == other)
			return true;
		if (!(other instanceof MultiRDBItemRecord))
			return false;
		return this.getId() == ((MultiRDBItemRecord) other).getId();
	}

	public int hashCode() {
		return getId().hashCode();
	}
 
}
