/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core.query;

import org.exoplatform.services.jcr.BasePortalTest;
import org.exoplatform.services.jcr.impl.core.query.sql.JCRSQLQueryBuilder;
import org.exoplatform.services.jcr.impl.core.query.xpath.XPathQueryBuilder;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: StatementTest.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class StatementTest extends BasePortalTest {
  
  private static final String REPOSITORY_NAME = "db1";//"mock";

  protected String getRepositoryName() {
    return REPOSITORY_NAME;
  }
  
  public void testXpathQueryBuilder() throws Exception {
    QueryRootNode rootNode = XPathQueryBuilder.createQuery("/jcr:node[1]", session.getLocationFactory());
    log.debug("Query>>>> "+rootNode.dump());
    String xpath = "/" + "/jcr:node[2]" + "/*[@jcr:primaryType='nt:unstructured' and fn:not(@mytext)]";
    rootNode = XPathQueryBuilder.createQuery(xpath, session.getLocationFactory());
    log.debug("Query>>>> "+rootNode.dump());

    
    //rootNode.getLocationNode();
    //rootNode.
  }

  public void testJCRSQLQueryBuilder() throws Exception {
    QueryRootNode rootNode = JCRSQLQueryBuilder.createQuery("SELECT * FROM nt:base", session.getLocationFactory());
    log.debug("Query>>>> "+rootNode.dump());
    String sql = "SELECT * FROM nt:base WHERE jcr:path LIKE '" + "jcr:node" + "/%' "+" AND birth > TIMESTAMP '1976-01-01T00:00:00.000+01:00'";
    //String xpath = "/" + "/jcr:node[2]" + "/*[@jcr:primaryType='nt:unstructured' and fn:not(@mytext)]";
    rootNode = JCRSQLQueryBuilder.createQuery(sql, session.getLocationFactory());
    log.debug("Query>>>> "+rootNode.dump());

    
    //rootNode.getLocationNode();
    //rootNode.
  }

}
