/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.database;

import java.util.Properties;

import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: $
 */

public interface HibernateConfiguration {
	/**
	 * Configures hibernate using array of classes
	 * @param classes 
	 * @throws HibernateException
	 */
	HibernateConfiguration addClasses(Class[] classes)
			throws HibernateException;

  HibernateConfiguration addClasses(Class[] classes, boolean createTables)
    throws HibernateException;  
  
	/**
	 * Configures hibernate using array of paths to mapping xml files
	 * @param path 
	 * @throws HibernateException
	 */
	HibernateConfiguration addMappingFiles(String[] path)
			throws HibernateException;

  HibernateConfiguration addMappingFiles(String[] path, boolean createTables)
    throws HibernateException;
  
	/**
	 * @return the SessionFactory
	 */
	SessionFactory getSessionFactory();
	
	
	/**
	 * @return Hibernate configuration property value
	 */
	String getHibernateProperty(String name);
	
	
	/**
	 * @return Hibernate's properties
	 */
	Properties getHibernateProperties();
	

	/**
	 * @return Hibernate's Configuration
	 */
	Configuration getConfiguration();

	
	/**
	 * @return HibernateService
	 */
	HibernateService getHibernateService();
}