/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.document.impl;

import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;

import org.exoplatform.container.component.ComponentPlugin;
import org.exoplatform.container.xml.InitParams;
import org.exoplatform.services.document.DocumentReaderService;
/**
 * Created by The eXo Platform SARL
 * Author : Phung Hai Nam
 *          phunghainam@gmail.com
 * Oct 19, 2005
 */
public class DocumentReaderServiceImpl implements DocumentReaderService {  
  private Map<String, BaseDocumentReader> readers_;
  
  public DocumentReaderServiceImpl(InitParams params){
    readers_ = new HashMap<String, BaseDocumentReader>();
  }
  
  public String getContentAsText(String  mimeType, InputStream is) throws Exception {    
    BaseDocumentReader reader = readers_.get(mimeType.toLowerCase());   
    if(reader != null)  return reader.getContentAsText(is);
    throw new Exception("Cannot handle the document type: " + mimeType);
  }
  
  public void addDocumentReader(ComponentPlugin plugin) {
    BaseDocumentReader reader = (BaseDocumentReader) plugin;
    readers_.put( reader.getMimeTypes().toLowerCase(),reader);
  }
}