 /***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.organization.ldap;

import org.exoplatform.container.xml.InitParams;
import org.exoplatform.services.ldap.LDAPService;
import org.exoplatform.services.organization.BaseOrganizationService;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Oct 14, 2005
 */
public class OrganizationServiceImpl extends  BaseOrganizationService  {
  
  public OrganizationServiceImpl(InitParams params, LDAPService ldapService) {
    String server = params.getValueParam("server").getValue();   
    LDAPAttributeMapping ldapAttrMapping = 
      (LDAPAttributeMapping)params.getObjectParam("ldap.attribute.mapping").getObject();
   
    if( server.equals("active.directory")){
      userHandler_ =  new ActiveDirectoryUserHandlerImpl(ldapAttrMapping, ldapService) ;
      groupHandler_ =  new ActiveDirectoryGroupHandlerImpl(ldapAttrMapping, ldapService);           
    }else{
      userHandler_ = new UserHandlerImpl(ldapAttrMapping, ldapService) ;
      groupHandler_ =  new GroupHandlerImpl(ldapAttrMapping, ldapService);      
    }   
    userProfileHandler_ =  new UserProfileHandlerImpl(ldapAttrMapping, ldapService) ;   
    membershipTypeHandler_ = new MembershipTypeHandlerImpl(ldapAttrMapping, ldapService) ;
    membershipHandler_ = new MembershipHandlerImpl(ldapAttrMapping, ldapService) ;
  }
}
