/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.faces.core.renderer.html;

import java.io.IOException;
import java.io.Writer;
import java.util.HashMap;
import java.util.Map;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.servlet.ServletContext;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.ComponentTemplate;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.services.templates.groovy.GroovyTemplateFileLoader;
import org.exoplatform.services.templates.groovy.GroovyTemplateService;
import org.exoplatform.services.templates.groovy.TemplateNotFoundException;

public  class GroovyRenderer extends  HtmlBasicRenderer {
  
  public void encodeChildren( FacesContext fcontext, UIComponent component ) throws IOException {
    String realName = null ;
    if(component instanceof ComponentTemplate) {
      realName =  ((ComponentTemplate)component).getTemplatePath() ;
    }  else {
      String name =  component.getClass().getName() ;
      realName = name.replaceFirst("component", "renderer/html") ;
      realName = realName.replace('.', '/') + ".gtmpl" ;
    }
    GroovyTemplateService tservice =
      (GroovyTemplateService) PortalContainer.getComponent(GroovyTemplateService.class) ;
    Writer writer =  fcontext.getResponseWriter() ;
    ResourceBundle res = getApplicationResourceBundle(fcontext.getExternalContext());
    Map<String, Object> binding =  new HashMap<String, Object>() ;
    binding.put(UIExoComponent.UICOMPONENT, component) ;
    binding.put("res", res) ;
    JSF jsf = new JSF((UIExoComponent) component, res, writer) ;
    binding.put("jsf", jsf) ;
    try {
      tservice.merge(writer, "any", realName, binding) ;
      return ;
    } catch (TemplateNotFoundException ex) {
    } catch (Exception ex) {
      System.err.println("\n\n\n\n\n") ;
      ex.printStackTrace() ;
      throw new IOException(ex.getMessage()) ;
    }
    ServletContext context = (ServletContext) fcontext.getExternalContext().getContext();
    String root = context.getRealPath("/") ;
    if(root == null) {
      throw new IOException("ServletContext does not support get real path, " +
                            "need to implement GroovyTemplateWarLoader") ;
    }
    GroovyTemplateFileLoader floader = new GroovyTemplateFileLoader(root + "/groovy") ;
    floader.setName(context.getServletContextName() +":file" ) ;
    tservice.addTemplateLoader(floader) ;
    try {
      tservice.merge(writer, "any", realName, binding) ;
    } catch (Exception ex) {
      System.err.println("\n\n\n\n\n") ;
      ex.printStackTrace() ;
      throw new IOException(ex.getMessage()) ;
    }
  }
}