/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.validator;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UIInput;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 13, 2004
 * @version $Id: EmptyStringValidator.java,v 1.4 2004/08/19 14:53:44 tuan08 Exp $
 */
public class IdentifierValidator implements Validator {
  public void validate(FacesContext context, 
                       UIComponent component, 
                       Object value) throws ValidatorException {
    String s = (String) value ;
    if(s == null || s.length() == 0) {
      UIInput uiInput = (UIInput) component ;
      Object[] args = {uiInput.getName()} ;
      throw new ValidatorException(new ExoFacesMessage("#{IdentifierValidator.msg.empty-input}", args)) ;
    }
    for(int i = 0; i < s.length() ; i++) {
      char c = s.charAt(i) ;
      if(Character.isLetter(c) || Character.isDigit(c) || c =='_' ) {
        continue ;
      }
      UIInput uiInput = (UIInput) component ;
      Object[] args = {uiInput.getName()} ;
      throw new ValidatorException(new ExoFacesMessage("#{IdentifierValidator.msg.invalid-char}", args)) ;
    }
  }
}	