/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.jmx.component;

import java.util.List;

import org.exoplatform.container.RootContainer;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UIPortlet;
import org.exoplatform.portlets.jmx.component.model.JMXServer;
import org.exoplatform.portlets.jmx.component.model.MBeanCategory;
/**
 * Jul 29, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIJMXPortlet.java,v 1.2 2004/08/01 04:18:27 tuan08 Exp $
 */
public class UIJMXPortlet extends UIPortlet {

  public UIJMXPortlet() throws Exception {
    setId("UIJMXPortlet") ;
    setClazz("UIJMXPortlet");
    setRendererType("VelocityRenderer") ;
    makeSureAllTheComponentsAreInit() ;
    UINavigator uiNavigator = (UINavigator)addChild(UINavigator.class) ;
    UIDetail uiDetail = (UIDetail) addChild(UIDetail.class) ;
    JMXServer server =  uiNavigator.getSelectJMXServer() ;
    MBeanCategory category = server.getDefaultCategory() ;
    category.setSelect(true) ;
    uiDetail.setViewUIListMBean(server, category) ;
  }
  
  private  void  makeSureAllTheComponentsAreInit() throws Exception {
    RootContainer root =  RootContainer.getInstance() ;
    List list = root.getComponentInstances() ;
    for(Object instance :  list) {
      if(instance instanceof PortalContainer) {
        PortalContainer pcontainer =   (PortalContainer)  instance ;
        pcontainer.getComponentInstances() ;
      }
    }
  }
}