/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.jvm.component;

import java.lang.management.MemoryPoolMXBean;
import java.util.List;

import org.exoplatform.container.RootContainer;
import org.exoplatform.container.monitor.jvm.JVMRuntimeInfo;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.text.ArrayFormater;
/**
 * May 31, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $ID$
 **/
public class UIMemoryPoolInfo extends UIExoCommand {
  private static String SHOW_DETAIL_ACTION = "detail" ;
  private static String SHOW_LIST_ACTION = "list" ;
  static String LIST_VIEW = "list", DETAIL_VIEW = "detail" ;
  
  static Parameter[] SHOW_LIST_PARAMS = { new Parameter(ACTION , SHOW_LIST_ACTION )} ;
  static Parameter[] SHOW_DETAIL_PARAMS = { new Parameter(ACTION , SHOW_DETAIL_ACTION )} ;
  
  private static ArrayFormater formater_ = new ArrayFormater(null, ", ") ;
  
  private MemoryPoolMXBean mxbean_ ;
  private List mxbeans_ ;
  private String view_ = LIST_VIEW ;
  
	public UIMemoryPoolInfo() {
		setRendererType("VelocityRenderer") ;
    mxbeans_ = 
      (List)RootContainer.getInstance().getComponentInstance(JVMRuntimeInfo.MEMORY_POOL_MXBEANS) ; 
    addActionListener(ShowDetailActionListener.class, SHOW_DETAIL_ACTION) ;
    addActionListener(ShowListActionListener.class, SHOW_LIST_ACTION) ;
	}
 
  public String getView() { return view_ ; }
  
  public List getMemoryPoolMXBeans() { return mxbeans_ ; }
  
  public MemoryPoolMXBean getMemoryPoolMXBean() { return mxbean_ ; }
  
  public Parameter[]  getShowListParams() { return SHOW_LIST_PARAMS ; }
  public Parameter[]  getShowDetailParams() { return SHOW_DETAIL_PARAMS ; }
  
  public ArrayFormater getArrayFormater() { return formater_ ; }
  
  static public class ShowDetailActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIMemoryPoolInfo uicomp = (UIMemoryPoolInfo) event.getComponent() ;
      String poolname = event.getParameter(OBJECTID) ; 
      List list = uicomp.mxbeans_ ;
      for(int i = 0; i < list.size(); i++) {
        MemoryPoolMXBean bean = (MemoryPoolMXBean) list.get(i) ;
        if(poolname.equals(bean.getName())) {
          uicomp.mxbean_ = bean ;
          uicomp.view_ = DETAIL_VIEW;
          return ;
        }
      }
    }
  }
  
  static public class ShowListActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIMemoryPoolInfo uicomp = (UIMemoryPoolInfo) event.getComponent() ;
      uicomp.view_ = LIST_VIEW ;
    }
  }
}