/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */
package org.exoplatform.portlets.monitor.component;

import java.util.Collection;

import org.exoplatform.commons.utils.ObjectPageList;
import org.exoplatform.container.SessionManager;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.UIPageListIterator;
import org.exoplatform.faces.core.component.model.PageListDataHandler;
/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 22 juin 2004
 */
public class UILiveSessions  extends UIExoCommand {
  
  private UIPageListIterator uiPageIterator_ ;
  
  public UILiveSessions(SessionManager smanager) throws Exception {
    setId("UILiveSessions") ;
    setRendererType("VelocityRenderer") ;
    uiPageIterator_ = new UIPageListIterator(new PageListDataHandler()) ;
    getChildren().add(uiPageIterator_);
    ObjectPageList plist = new ObjectPageList(smanager.getLiveSessions(), 20) ;
    uiPageIterator_.setPageList(plist) ;
  }
  
  
  public Collection getLiveSessions(){  
    return uiPageIterator_.getPageListDataHandler().getDatas();  
  }
}