/***************************************************************************
 * Copyright 2001-2003 The VietSpider Studio        All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.impl.converter.v11tov2;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.services.portal.model.Container;
import org.exoplatform.services.portal.model.Portlet;
import org.exoplatform.xml.object.XMLObject;

/**
 * Created by VietSpider Studio
 * Author : Nhu Dinh Thuan
 *          nhudinhthuan@yahoo.com
 * Dec 16, 2005
 */
public class PortalLayoutConverter extends ObjectConverter {
  
  public void update(  XMLObject xmlobject, String name, Object o, Object n)throws Exception {   
    Container pre = (Container)xmlobject.getField("portalLayout").getObject().toObject();
    Container last = new Container();
    last.setDecorator( pre.getDecorator());
    last.setHeight( pre.getHeight());
    last.setId( pre.getId());
    last.setRenderer( pre.getRenderer());
    last.setTitle( pre.getTitle());
    last.setWidth( pre.getWidth());
    
    List list = new ArrayList();
    List children = pre.getChildren();
    
    Portlet p = findPortlet( children, "/content/DisplayStaticContent/banner");
    list.add( p);
    
    Container conToolbar = new Container();
    conToolbar.setDecorator( "community-toolbar");    
    conToolbar.setRenderer( "ContainerColumnRenderer");
    conToolbar.setId( null);
    List listToolbar = new ArrayList();
    p = findPortlet( children, "/web/NavigationPortlet/community-toolbar");
    if( p != null) listToolbar.add( p);
    p = findPortlet( children, "/user/WelcomePortlet/welcome-user");
    if( p != null) listToolbar.add( p);    
    conToolbar.setChildren( listToolbar);
    list.add( conToolbar);
    
    p = findPortlet( children, "/web/PortalModePortlet/portal-edit-mode");
    if( p == null){    
      p = new Portlet();
      p.setDecorator("default");
      p.setRenderer( "default");
      p.setShowInfoBar( false);
      p.setShowPortletMode( false);
      p.setShowWindowState( false);
      p.setPortletStyle("portal-mode");
      p.setId( null);
      p.setWindowId(xmlobject.getFieldValue("owner")+":/web/PortalModePortlet/portal-edit-mode");
    }
    list.add( p);
    
    removeEmptyContainer( children);
    for( int i =0; i<children.size(); i++){
      list.add( children.get(i));
    }
    
    last.setChildren( list);
    xmlobject.removeField( "portalLayout");
    xmlobject.addField( "portalLayout", last.getClass(), last);    
  }
  private Portlet findPortlet( List list, String id) throws Exception{
    Portlet p = null;
    for( int i =0; i<list.size(); i++){
      if( list.get( i) instanceof Container) {
        p = findPortlet( ((Container)list.get( i)).getChildren(), id);        
      }else if ( list.get( i) instanceof Portlet){
        if( ((Portlet)list.get( i)).getWindowId().indexOf( id) > -1)
          p  = (Portlet)list.get( i);
      }
      if ( p != null){        
        list.remove( p);        
        break;
      }
    }
     return p;
  } 
  
  private void removeEmptyContainer(List list) throws Exception{  
    Portlet p = null;
    for(int i =0; i<list.size(); i++){
      if(list.get( i) instanceof Container) {
         Container con = (Container) list.get( i);
         if( con.getChildren().size() <= 0 ){
           list.remove( i);
           i--;
         }else{
           removeEmptyContainer( con.getChildren());
         }
      }
    }    
  } 
}
