/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.validator;

import java.io.ByteArrayInputStream;
import java.io.FileOutputStream;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.exoplatform.test.web.ExoWebClient;
import org.xml.sax.helpers.DefaultHandler;

import com.meterware.httpunit.WebResponse;
/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: WellFormedXhtmlValidator.java,v 1.1 2004/10/11 23:36:06 tuan08 Exp $
 **/
public class WellFormedXhtmlValidator implements Validator {
  private DefaultHandler handler_ = new DefaultHandler() ;
  
  public boolean validate(WebResponse response, ExoWebClient client)  throws Exception {
    String xhtml =  response.getText();
    try {
      ByteArrayInputStream is = new ByteArrayInputStream(xhtml.getBytes()) ;
      SAXParserFactory factory = SAXParserFactory.newInstance();
      factory.setNamespaceAware(true);
      factory.setValidating(false);
      SAXParser saxParser = factory.newSAXParser();
      saxParser.parse(is, handler_) ;
    } catch (Exception ex) {
     System.out.println("Validate xhtml error: " + ex.getMessage()) ;
     FileOutputStream out = new FileOutputStream("./target/output.html") ;
     out.write(xhtml.getBytes()) ;
     return false ;
    }
    return true ;
  }
  
  public String getName() { return "WellFormedXhtmlValidator" ; }
  
  public String getDescription()  { 
    return "Make sure that the return xhtml is well formed." ;
  }
}