/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package control;

import java.util.Map ;
import java.util.HashMap ;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.test.web.* ;
import org.exoplatform.test.web.servlet.* ;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Dec 21, 2005
 */
public class SelectTest extends ActionHandler { 
  private Map availableTests_ ;
  
  public SelectTest() {
    availableTests_ = new HashMap() ;
    /*-----------------------PORTAL'S TEST SUITES--------------*/    
    availableTests_.put("suites.runner.PortalAdminSuites", "Portal Admin's Suites") ;
    availableTests_.put("suites.runner.PortalUserSuites", "Portal Customization") ;
    
    availableTests_.put("suites.web.CheckAllLinkSuite", "Check All Admins's Pages") ;
    
    availableTests_.put("suites.admin.AdminConsoleSuites", "Admin Console ") ;
    availableTests_.put("suites.admin.IndexingPortletAdminSuite", "Portal Indexing ") ;
    availableTests_.put("suites.admin.PortalAdminSuite", "Portal Administration ") ;
    availableTests_.put("suites.admin.PortletRegistrySuite", "Portlet Registration ") ;
    availableTests_.put("suites.admin.ResourceBundlePortletSuite", "Resource Management") ;
    
    availableTests_.put("suites.jmx.JMXMonitoringPortletAdminSuite", "JMX Monitoring") ;
                
    availableTests_.put("suites.portal.CustomizationPortalSuite", "Portal Customization") ;
    availableTests_.put("suites.portal.CustomizationNavigationSuite", "Navigation Customization") ;
    availableTests_.put("suites.portal.CustomizationPageSuite", "Page Customization") ;
    
    availableTests_.put("suites.user.OrganizationPortletSuite", "Organization Managemement") ;
    availableTests_.put("suites.user.GroupManagementSuite", "Group Management") ;
    availableTests_.put("suites.user.UsersManagementSuite", "User Management") ;
    availableTests_.put("suites.user.MembershipManagementSuite", "Membership Management") ;
    
    availableTests_.put("suites.forum.ForumPortletAdminSuite", "Forum Administration") ;
    availableTests_.put("suites.forum.ForumPortletUserSuite", "User Forum") ;
    
    availableTests_.put("suites.fileexplorer.FileExplorerPortletAdminSuite", "Admin File Explorer") ;
    availableTests_.put("suites.fileexplorer.FileExplorerPortletUserSuite", "User File Explorer") ;
   
    availableTests_.put("suites.workflow.WorkflowPortletAdminSuite", "Workflow Administration") ;
    availableTests_.put("suites.workflow.WorkflowPortletUserSuite", "User  Workflow ") ;
    
    availableTests_.put("suites.wsrp.WSRPAdminPortletSuite", "WSRP Administration") ;
    availableTests_.put("suites.wsrp.WSRPConsummerPortletSuite", "Consummer WSRP ") ;
    
    availableTests_.put("suites.message.MessagePortletUserSuite", "User Message Portlet") ;
    
    availableTests_.put("suites.content.ContentPortletSuite", "Conntent Portlet") ;
    availableTests_.put("suites.ecm.EcmPortletAdminSuite", "Ecm Portlet Admin") ;    
    /*-------------------------CMS'S TEST SUITES----------*/
    availableTests_.put("suites.runner.CMSPortalAdminSuites", "CMS Admin's Suites") ;
    availableTests_.put("suites.runner.CMSPortalUserSuites", "CMS Customization") ;
    
    availableTests_.put("suites.cmscontent.JCRExplorerUserSuite", "JCR Explorer") ;    
  }
  
  public void execute(HttpServletRequest request, HttpServletResponse response) {
    ResourceManager resManager = getResourceManager() ;
    Map  binding =  resManager.createDefaultBinding(request) ;
    String suite = request.getParameter("suite") ;
    if(suite != null) {
      def config = getConfiguration() ;
      def client = config.getWebClient() ;
      def suites = config.getTestSuites(resManager, suite) ;
      client.setSuites(suites) ;
      binding.put("suites", suites) ;
      resManager.merge(response.getWriter(), "templates/RunTest.groovy", binding);
    } else {
      binding.put("availableTests", availableTests_) ;
      resManager.merge(response.getWriter(), "templates/SelectTest.groovy", binding);
    }
  }
}